package com.hisschemoller.audio.model.vo 
{
	import com.hisschemoller.audio.model.enum.AudioProcessorType;

	/**
	 * @author Wouter Hisschemoller
	 * Feb 5, 2010
	 * 
	 * Base data object with settings for instruments that play samples.
	 */
	public class SampleProgramVO extends ProgramVO 
	{
		public var soundID : String;

		public function SampleProgramVO()
		{
			super();
			
			super.type = AudioProcessorType.SAMPLE_PROCESSOR;
		}

		override public function parseXML(o : XML) : Boolean
		{
			var success : Boolean = super.parseXML(o);
			
			soundID = o.@sound_id;
			
			return success;
		}

		override public function clone() : ProgramVO
		{
			var programVO : SampleProgramVO = new SampleProgramVO();
			programVO.id = id;
			programVO.type = type;
			programVO.soundID = soundID;
			
			return programVO;
		}
	}
}
