package com.hisschemoller.audio.utils.delegates 
{
	import de.popforge.audio.output.Audio;

	import com.hisschemoller.audio.utils.delegates.vo.AudioLoaderVO;
	import com.hisschemoller.ui.utils.StageReference;
	import com.hisschemoller.utils.responder.Responder;

	import flash.display.Stage;
	import flash.events.Event;

	/**
	 * @author Wouter Hisschemoller
	 * May 9, 2010
	 */
	public class ByteArrayToVectorDelegate 
	{
		private var _responder : Responder;
		private var _decodedStack : Vector.<AudioLoaderVO>;
		private var _convertingAudio : AudioLoaderVO;
		private var _convertedStack : Vector.<AudioLoaderVO> = new Vector.<AudioLoaderVO>();
		private var _stage : Stage;
		private var _frameDurationInMS : int;
		private var _frameEndTime : int;
		private var _savedIndex : uint;
		private var _numSamples : uint;
		private var _bytesPerMonoSample : uint;

		public function ByteArrayToVectorDelegate(responder : Responder)
		{
			_responder = responder;
		}

		/**
		 * 
		 */
		public function convertAudio(decodedStack : Vector.<AudioLoaderVO>, bytesPerMonoSample : uint) : void
		{
			/** If there's nothing to convert end the process. */
			if(decodedStack.length == 0)
			{
				_responder.result(_convertedStack);
				return;
			}
			
			if(!StageReference.stage) _responder.fault("Error converting ByteArray to Vector: There's no Stage instance to add a ENTER_FRAME listener.");
			
			_decodedStack = decodedStack;
			_bytesPerMonoSample = bytesPerMonoSample;
			_stage = StageReference.stage;
			_stage.addEventListener(Event.ENTER_FRAME, enterFrameHandler);
			_frameDurationInMS = 1000 / _stage.frameRate;
			
			// ProgressPopup.show("Converting audio file");
			
			getNextAudioFile();
		}

		/**
		 * 
		 */
		private function getNextAudioFile() : void
		{
			if(_decodedStack.length == 0 && _convertingAudio == null)
			{
				/** All done. */
				// ProgressPopup.hide();
				_stage.removeEventListener(Event.ENTER_FRAME, enterFrameHandler);
				_responder.result(_convertedStack);
				return;
			}
			
			/** Get next object to convert. */
			_convertingAudio = _decodedStack.shift();
			_savedIndex = 0;
			_numSamples = _convertingAudio.byteArray.length / (_bytesPerMonoSample * Audio.STEREO);
			_convertingAudio.samples = new Vector.<Vector.<Number>>(2, true);
			_convertingAudio.samples[0] = new Vector.<Number>(_numSamples, true);
			_convertingAudio.samples[1] = new Vector.<Number>(_numSamples, true);
			_convertingAudio.byteArray.position = 0;
		}

		/**
		 * 
		 */
		private function enterFrameHandler(event : Event) : void
		{
			var l : Vector.<Number> = _convertingAudio.samples[0]; /** left channel */
			var r : Vector.<Number> = _convertingAudio.samples[1]; /** right channel */
			
			_frameEndTime = new Date().getTime() + _frameDurationInMS;
			var pollCounter : uint = 0;
			// ProgressPopup.value = _savedIndex / _numSamples;
			
			if(_convertingAudio.channels == Audio.MONO)
			{
				for(var i : uint = _savedIndex; i < _numSamples; i++)
				{
					pollCounter ++;
					if(pollCounter > 10000)
					{
						pollCounter = 0;
						
						if(new Date().getTime() > _frameEndTime)
						{
							_savedIndex = i;
							return;
						}
					}
					
					l[i] = _convertingAudio.byteArray.readFloat();
					r[i] = l[i];
					_convertingAudio.byteArray.readFloat();
				}
			}
			else if(_convertingAudio.channels == Audio.STEREO)
			{
				for(i = _savedIndex; i < _numSamples; i++)
				{
					pollCounter ++;
					if(pollCounter > 10000)
					{
						pollCounter = 0;
						
						if(new Date().getTime() > _frameEndTime)
						{
							_savedIndex = i;
							return;
						}
					}
					
					l[i] = _convertingAudio.byteArray.readFloat();
					r[i] = _convertingAudio.byteArray.readFloat();
				}
			}
			
//			for(var i : uint = _savedIndex; i < _numSamples; i++)
//			{
//				pollCounter ++;
//				if(pollCounter > 10000)
//				{
//					pollCounter = 0;
//					
//					if(new Date().getTime() > _frameEndTime)
//					{
//						_savedIndex = i;
//						return;
//					}
//				}
//				
//				if(_convertingAudio.channels == Audio.MONO)
//				{
//					l[i] = _convertingAudio.byteArray.readFloat();
//					r[i] = l[i];
//					_convertingAudio.byteArray.readFloat();
//				}
//				else if(_convertingAudio.channels == Audio.STEREO)
//				{
//					l[i] = _convertingAudio.byteArray.readFloat();
//					r[i] = _convertingAudio.byteArray.readFloat();
//				}
//			}
			
			_convertedStack.push(_convertingAudio);
			_convertingAudio = null;
			getNextAudioFile();
		}
	}
}
