package com.hisschemoller.audio.utils.delegates 
{
	import com.hisschemoller.audio.model.enum.AudioProcessorType;
	import com.hisschemoller.audio.model.vo.LoopedSampleProgramVO;
	import com.hisschemoller.audio.model.vo.SoundVO;
	import com.hisschemoller.utils.responder.Responder;

	/**
	 * @author Wouter Hisschemoller
	 * May 1, 2010
	 */
	public class NewProgramDelegate 
	{
		private var _responder : Responder;
		
		public function NewProgramDelegate(responder : Responder)
		{
			_responder = responder;
		}
		
		/**
		 * Creates a new instrument program VO.
		 */
		public function createNewProgram(programType : String, programXML : XML, soundVO : SoundVO = null) : void
		{
			switch(programType)
			{
				case AudioProcessorType.LOOPED_SAMPLE_PROCESSOR:
					/** If no ID is provided generate one. */
					if(programXML.@id == "") programXML.@id = "sampleProgram_" + new Date().getTime();
					
					var loopProgramVO : LoopedSampleProgramVO = new LoopedSampleProgramVO();
					loopProgramVO.id = programXML.@id;
					loopProgramVO.type = programXML.@type;
					loopProgramVO.reverse = (programXML.@reverse == "true");
					loopProgramVO.loop = (programXML.@loop == "true");
					loopProgramVO.transpose = programXML.@transpose;
					loopProgramVO.tune = programXML.@tune;
					loopProgramVO.soundID = programXML.@sound_id;
					loopProgramVO.start = (String(programXML.@start).length != 0) ? int(programXML.@start) : 0;
					loopProgramVO.end = (String(programXML.@end).length != 0) ? int(programXML.@end) : soundVO.numSamplesTotal;
					
					_responder.result(loopProgramVO);
					break;
				
				default:
					_responder.fault("Unknown program type.");
					break;
			}
		}
	}
}
