package com.hisschemoller.sequencer
{
	import com.hisschemoller.audio.notification.AudioNotifications;
	import com.hisschemoller.sequencer.notification.SeqNotifications;

	import org.puremvc.as3.multicore.interfaces.IFacade;
	import org.puremvc.as3.multicore.patterns.facade.Facade;
	import org.puremvc.as3.multicore.patterns.observer.Notification;

	/**
	 * @author wouter.hisschemoller
	 * Mar 1, 2010
	 */
	public class AppFacade extends Facade implements IFacade 
	{
		public function AppFacade (key : String)
		{
			super( key );
		} 

		/**
		 * Singleton ApplicationFacade Factory Method
		 */
		public static function getInstance (key : String) : AppFacade 
		{
			if(instanceMap[key] == null) instanceMap[key] = new AppFacade( key );
			
			return instanceMap[key] as AppFacade;
		}

		/**
		 * Broadcast the STARTUP Notification
		 */
		public function startup (app : Object) : void 
		{
			notifyObservers( new Notification( SeqNotifications.STARTUP, app ) );
		}

		/**
		 * Register Commands with the Controller
		 */
		override protected function initializeController () : void 
		{
			super.initializeController( );
			
			AudioNotifications.initializeController( this );
			SeqNotifications.initializeController( this );
		}
	}
}
