package com.hisschemoller.sequencer.controller 
{
	import com.hisschemoller.sequencer.model.SequencerProxy;
	import com.hisschemoller.sequencer.model.vo.PatternVO;
	import com.hisschemoller.sequencer.model.vo.SeqEventVO;
	import com.hisschemoller.sequencer.model.vo.SequenceVO;
	import com.hisschemoller.sequencer.notification.SeqNotifications;

	import org.puremvc.as3.multicore.interfaces.INotification;
	import org.puremvc.as3.multicore.patterns.command.SimpleCommand;
	/**
	 * @author wouterhisschemoller
	 * 
	 * Add a new event to a pattern in the current sequence.
	 */
	public class CreateEventCommand extends SimpleCommand 
	{
		override public function execute (note : INotification) : void
		{
			var seqEventVO : SeqEventVO = note.getBody( ) as SeqEventVO;
			var sequencerProxy : SequencerProxy = facade.retrieveProxy( SequencerProxy.NAME ) as SequencerProxy;
			var sequenceVO : SequenceVO = sequencerProxy.selectedSequence;
			var n : uint = sequenceVO.patterns.length;
			while(--n > -1)
			{
				var patternVO : PatternVO = sequenceVO.patterns[n];
				if( patternVO.trackID == seqEventVO.trackID )
				{
					var m : uint = patternVO.events.length;
					while(--m > -1)
					{
						var eventVO : SeqEventVO = patternVO.events[m];
						if(eventVO.time <= seqEventVO.time)
						{
							addEvent( patternVO, m + 1, seqEventVO );
							return;
						}
					}
					
					/** An event earlier than the new one wasn't found, so put the new event at index 0.  */
					addEvent( patternVO, 0, seqEventVO );
					return;
				}
			}
		}

		/**
		 * 
		 */
		private function addEvent (patternVO : PatternVO, insertPosition : uint, seqEventVO : SeqEventVO) : void
		{
			if(insertPosition <= patternVO.currentEventIndex)
			{
				patternVO.currentEventIndex += 1;
			}
			
			patternVO.events.splice( insertPosition, 0, seqEventVO );
			sendNotification( SeqNotifications.SEQ_EVENT_CREATED, seqEventVO );
		}
	}
}
