package com.hisschemoller.sequencer.controller 
{
	import com.hisschemoller.sequencer.model.SequencerProxy;
	import com.hisschemoller.sequencer.model.vo.PatternVO;
	import com.hisschemoller.sequencer.model.vo.SeqEventVO;
	import com.hisschemoller.sequencer.model.vo.SequenceVO;
	import com.hisschemoller.sequencer.notification.SeqNotifications;

	import org.puremvc.as3.multicore.interfaces.INotification;
	import org.puremvc.as3.multicore.patterns.command.SimpleCommand;
	/**
	 * @author wouterhisschemoller
	 */
	public class DeleteEventCommand extends SimpleCommand 
	{
		/**
		 * Remove an event from a pattern in the current sequence.
		 */
		override public function execute (note : INotification) : void
		{
			var seqEventVO : SeqEventVO = note.getBody( ) as SeqEventVO;
			var sequencerProxy : SequencerProxy = facade.retrieveProxy( SequencerProxy.NAME ) as SequencerProxy;
			var sequenceVO : SequenceVO = sequencerProxy.selectedSequence;
			var n : uint = sequenceVO.patterns.length;
			while( --n > -1 )
			{
				var patternVO : PatternVO = sequenceVO.patterns[ n ];
				if( patternVO.trackID == seqEventVO.trackID )
				{
					var m : uint = patternVO.events.length;
					while(--m > -1)
					{
						var eventVO : SeqEventVO = patternVO.events[ m ];
						if( eventVO == seqEventVO )
						{
							patternVO.events.splice( m, 1 );
							sendNotification( SeqNotifications.SEQ_EVENT_DELETED, seqEventVO );
							return;
						}
					}
				}
			}
		}
	}
}
