package com.hisschemoller.sequencer.controller 
{
	import com.hisschemoller.sequencer.model.SequencerProxy;
	import com.hisschemoller.sequencer.model.vo.PatternVO;
	import com.hisschemoller.sequencer.model.vo.SequenceVO;

	import org.puremvc.as3.multicore.interfaces.INotification;
	import org.puremvc.as3.multicore.patterns.command.SimpleCommand;
	/**
	 * @author Wouter Hisschemoller
	 * (c) Jan 8, 2011
	 */
	public class UpdatePatternCommand extends SimpleCommand 
	{
		/**
		 * Update pattern with changed data.
		 */
		override public function execute ( note : INotification ) : void
		{
			var settings : PatternVO = note.getBody( ) as PatternVO;
			var trackChanged : Boolean = false;
			
			var sequencerProxy : SequencerProxy = facade.retrieveProxy( SequencerProxy.NAME ) as SequencerProxy;
			var sequences : Vector.<SequenceVO> = sequencerProxy.sequences;
			
			if( settings.trackID )
			{
				trackChanged = true;
				
				/** Loop through sequences. */
				var n : int = sequences.length;
				while( --n > -1 )
				{
					/** Loop through patterns. */
					var sequenceVO : SequenceVO = sequences[ n ];
					var m : int = sequenceVO.patterns.length;
					while( --m > -1 )
					{
						/** Look up pattern. */
						var patternVO : PatternVO = sequenceVO.patterns[ m ];
						if( patternVO.id == settings.id )
						{
							if( patternVO.trackID != settings.trackID )
							{
								patternVO.trackID = settings.trackID;
							}
						}
					}
				}
			}
		}
	}
}
