package com.hisschemoller.sequencer.view 
{
	import com.hisschemoller.sequencer.notification.SeqNotifications;
	import com.hisschemoller.sequencer.view.components.settings.SettingsWindow;
	import com.hisschemoller.sequencer.view.enum.UIEventType;
	import com.hisschemoller.sequencer.view.enum.UILayout;

	import org.puremvc.as3.multicore.interfaces.INotification;
	import org.puremvc.as3.multicore.patterns.mediator.Mediator;

	import flash.events.Event;
	import flash.utils.getQualifiedClassName;

	/**
	 * @author wouterhisschemoller
	 */
	public class SettingsWindowMediator extends Mediator 
	{
		public static const NAME : String = getQualifiedClassName( SettingsWindowMediator );

		public function SettingsWindowMediator (viewComponent : Object)
		{
			super( NAME, viewComponent );
		}

		/**
		 * 
		 */
		override public function listNotificationInterests () : Array
		{
			return [ SeqNotifications.SEQ_SHOW_SETTINGS ];
		}

		/**
		 * 
		 */
		override public function handleNotification ( notification : INotification ) : void
		{
			switch(notification.getName( ))
			{
				case SeqNotifications.SEQ_SHOW_SETTINGS:
					view.show( notification.getBody() as String );
					break;
			}
		}

		/**
		 * 
		 */
		override public function onRegister () : void
		{
			view.move( 300, 120 );
			view.setSize( UILayout.SETTINGS_WIDTH, UILayout.SETTINGS_HEIGHT );
			view.title = "Settings";
			view.hide( );
			view.addEventListener( UIEventType.SETTINGS_CLOSE, UIEventHandler );
		}

		/**
		 * 
		 */
		override public function onRemove () : void
		{
			view.removeEventListener( UIEventType.SETTINGS_CLOSE, UIEventHandler );
		}

		/**
		 * 
		 */
		private function UIEventHandler ( event : Event ) : void
		{
			switch(event.type)
			{
				case UIEventType.SETTINGS_CLOSE:
					view.hide( );
					break;
			}
		}

		/**
		 * 
		 */
		private function get view () : SettingsWindow
		{
			return getViewComponent( ) as SettingsWindow;
		}
	}
}
