package com.hisschemoller.sequencer.view.components 
{
	import com.bit101.components.Component;

	import flash.display.DisplayObjectContainer;
	import flash.display.Shape;
	import flash.events.Event;

	/**
	 * @author wouterhisschemoller
	 */
	public class Busy extends Component 
	{
		private var _sink : Shape;
		private var _spinner : Shape;

		public function Busy (parent : DisplayObjectContainer = null, xpos : Number = 0, ypos : Number = 0)
		{
			super( parent, xpos, ypos );
		}

		public function updateBusy (isBusy : Boolean) : void
		{
			if(isBusy == visible)
			{
				return;
			}
			
			visible = isBusy;
			
			if(visible)
			{
				addEventListener( Event.ENTER_FRAME, enterframeHandler );
			}
			else
			{
				removeEventListener( Event.ENTER_FRAME, enterframeHandler );
			}
		}

		override protected function addChildren () : void
		{
			_sink = new Shape( );
			_sink.graphics.beginFill( 0xFFFFFF, 0.6 );
			_sink.graphics.drawRect( 0, 0, stage.stageWidth, stage.stageHeight );
			addChild( _sink );
			
			_spinner = new Shape( );
			_spinner.x = stage.stageWidth / 2;
			_spinner.y = stage.stageHeight / 2;
			_spinner.graphics.beginFill( 0x999999 );
			_spinner.graphics.drawCircle( Math.cos( 0 ) * 15, Math.sin( 0 ) * 15, 6 );
			_spinner.graphics.drawCircle( Math.cos( Math.PI * 0.66 ) * 15, Math.sin( Math.PI * 0.66 ) * 15, 6 );
			_spinner.graphics.drawCircle( Math.cos( Math.PI * 1.32 ) * 15, Math.sin( Math.PI * 1.32 ) * 15, 6 );
			addChild( _spinner );
		}

		private function enterframeHandler (event : Event) : void 
		{
			_spinner.rotation += 10;
		}
	}
}
