package com.hisschemoller.sequencer.view.components.euclidpattern 
{
	import flash.utils.setTimeout;
	import com.bit101.components.Component;
	import com.greensock.TweenLite;
	import com.hisschemoller.utils.IDisposable;

	import flash.display.DisplayObjectContainer;
	/**
	 * @author wouterhisschemoller
	 */
	public class EuclidStep extends Component implements IDisposable 
	{
		public static const RADIUS : int = 4;
		private var _selected : Boolean;

		public function EuclidStep (parent : DisplayObjectContainer = null, xpos : Number = 0, ypos : Number = 0, selected : Boolean = false )
		{
			_selected = selected;
			
			super( parent, xpos, ypos );
		}
		
		public function dispose( ) : void
		{
		}
		
		/**
		 * 
		 */
		public function hit( delay : int ) : void
		{
			setTimeout( delayedHit, delay);
			
		}

		private function delayedHit () : void 
		{
			TweenLite.from( this, 0.5, { scaleX:2, scaleY:2 } );
		}

		/**
		 * Overriden in subclasses to create child display objects.
		 */
		override protected function addChildren () : void
		{
			if( _selected )
			{
				graphics.beginFill( 0x999999 );
			}
			else
			{
				graphics.beginFill( 0xFFFFFF );
			}
			
			graphics.lineStyle( 2, 0x666666 );
			graphics.drawEllipse( -RADIUS, -RADIUS, RADIUS * 2, RADIUS * 2 );
		}
	}
}
