package com.hisschemoller.sequencer.view.components.linearpattern 
{
	import com.bit101.components.PushButton;
	import com.hisschemoller.sequencer.model.vo.SeqEventVO;
	import com.hisschemoller.utils.IDisposable;

	import flash.display.DisplayObjectContainer;
	import flash.events.MouseEvent;

	/**
	 * @author wouterhisschemoller
	 */
	public class PatternEditorStep extends PushButton implements IDisposable
	{
		private var _seqEventVO : SeqEventVO;

		public function PatternEditorStep (seqEventVO : SeqEventVO, parent : DisplayObjectContainer = null, xpos : Number = 0, ypos : Number = 0, label : String = "", defaultHandler : Function = null) 
		{
			_seqEventVO = seqEventVO;
			
			super( parent, xpos, ypos, label, defaultHandler );
		}
		
		/**
		 * Clean up before deletion.
		 */
		public function dispose () : void
		{
			_seqEventVO = null;
			
			removeEventListener(MouseEvent.MOUSE_DOWN, onMouseGoDown);
			removeEventListener(MouseEvent.ROLL_OVER, onMouseOver);
			removeEventListener(MouseEvent.ROLL_OUT, onMouseOut);
			stage.removeEventListener(MouseEvent.MOUSE_UP, onMouseGoUp);
		}

		/**
		 * 
		 */
		public function get seqEventVO () : SeqEventVO
		{
			return _seqEventVO;
		}
		
		public function set seqEventVO (seqEventVO : SeqEventVO) : void
		{
			_seqEventVO = seqEventVO;
		}
		
		/**
		 * Initializes the component.
		 * Overridden because PushButton sets the width to 100.
		 */
		override protected function init():void
		{
			setSize(20, 20);
			addChildren();
			invalidate();
			buttonMode = true;
			useHandCursor = true;
		}
	}
}
