package com.hisschemoller.sequencer.view.components.settings 
{
	import com.bit101.components.Knob;
	import com.bit101.components.Label;
	import com.bit101.components.Window;
	import com.hisschemoller.sequencer.view.enum.UILayout;

	import flash.display.DisplayObjectContainer;
	import flash.events.MouseEvent;

	/**
	 * @author wouterhisschemoller
	 */
	public class InstrumentSettings extends Window 
	{
		private var _volumeKnob : Knob;

		public function InstrumentSettings (parent : DisplayObjectContainer = null, xpos : Number = 0, ypos : Number = 0)
		{
			super( parent, xpos, ypos );
		}

		override protected function init () : void
		{
			super.init( );
			
			title = "Instrument Settings";
			shadow = false;
			hasMinimizeButton = true;
			_minimizeButton.removeEventListener( MouseEvent.CLICK, onMinimize );
		}

		override protected function addChildren () : void
		{
			super.addChildren( );
			
			_volumeKnob = new Knob( _panel, 20, 10, "Gain" );
			_volumeKnob.radius = 12;
			_volumeKnob.minimum = -10;
			_volumeKnob.maximum = 10;
			_volumeKnob.enabled = false;
			
			var label : Label = new Label( _panel, 20, 80, "This panel is meant to be used \nto edit properties of the selected \nsound. \nLike volume, pan, pitch etcetera. \nBut that part isn't implemented \nin this version." );
			label.textField.multiline = true;
			label.textField.wordWrap = true;
			label.width = UILayout.SETTINGS_WIDTH - (UILayout.SETTINGS_H_PADDING * 2);
		}
	}
}
