package com.hisschemoller.utils 
{
	/**
	 * @author Wouter Hisschemoller
	 * (c) Jan 6, 2011
	 */
	public class EuclidGenerator_OLD
	{
		private var _pattern : Vector.<Boolean> = new Vector.<Boolean>( );

		public function EuclidGenerator_OLD ( total : int, hits : int )
		{
			_pattern = Vector.<Boolean>( eugen( total, hits ) );
			
			// log( "d eugen: " + _pattern );
		}

		public function get pattern () : Vector.<Boolean>
		{
			return _pattern;
		}

		private function eugen (total : int, hits : int) : Array
		{
			var r : Array = new Array( );
			if (hits >= total || total == 1 || hits == 0) 
			{ 
				//test for input for sanity
				if (hits >= total) 
				{
					for (var i : uint = 0; i < total; i++) 
					{ 
						//give trivial rhythm of a pulse on every step
						r.push( 1 );
					}
				} 
				else if (total == 1) 
				{
					if (hits == 1) 
					{
						r.push( 1 );
					} 
					else 
					{
						r.push( 0 );
					}
				} 
				else 
				{
					for (i = 0; i < total; i++) 
					{
						r.push( 0 );
					}
				}
			} 
			else 
			{ 
				//sane input
				var pauses : int = total - hits;
				if (pauses >= hits) 
				{ 
					//first case more pauses than p
					var per_pulse : int = Math.floor( pauses / hits );
					var remainder : int = pauses % hits;
					for (i = 0; i < hits; i++) 
					{
						r.push( 1 );
						for (var j : uint = 0; j < per_pulse; j++) 
						{
							r.push( 0 );
						}
						if (i < remainder) 
						{
							r.push( 0 );
						}
					}
				} 
				else 
				{ 
					//second case more p than pauses
					var per_pause : int = Math.floor( (hits - pauses) / pauses );
					remainder = (hits - pauses) % pauses;
					for (i = 0; i < pauses; i++) 
					{
						r.push( 1 );
						r.push( 0 );
						for (j = 0; j < per_pause; j++) 
						{
							r.push( 1 );
						}
						if (i < remainder) 
						{
							r.push( 1 );
						}
					}
				}
			}
			
			/** Convert 0 | 1 to false | true. */
			for(i = 0; i < r.length; i++)
			{
				r[ i ] = ( r[ i ] == 1 );
			}
			
			return r;
		}
	}
}
