package com.hisschemoller.utils.delegates 
{
	import com.hisschemoller.ui.model.vo.AlertVO;
	import com.hisschemoller.utils.responder.Responder;

	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.ProgressEvent;
	import flash.events.SecurityErrorEvent;
	import flash.net.URLLoader;
	import flash.net.URLLoaderDataFormat;
	import flash.net.URLRequest;

	/**
	 * @author wouter.hisschemoller
	 * (c) Lost Boys Mar 1, 2010
	 */
	public class FileLoaderDelegate 
	{
		private var _responder : Responder;
		private var _urlLoader : URLLoader;
		private var _isLoading : Boolean;
		
		public function FileLoaderDelegate(responder : Responder)
		{
			_responder = responder;
		}
		
		/**
		 * 
		 */
		public function loadFile(url : String) : void
		{
			_urlLoader = new URLLoader();
			_urlLoader.dataFormat = URLLoaderDataFormat.BINARY;
			_urlLoader.addEventListener(Event.COMPLETE, urlLoaderEventHandler);
			_urlLoader.addEventListener(Event.OPEN, urlLoaderStartedHandler);
			_urlLoader.addEventListener(ProgressEvent.PROGRESS, urlLoaderProgressEventHandler);
			_urlLoader.addEventListener(SecurityErrorEvent.SECURITY_ERROR, urlLoaderEventHandler);
			_urlLoader.addEventListener(IOErrorEvent.IO_ERROR, urlLoaderEventHandler);
			_urlLoader.load(new URLRequest(url));
		}

		/**
		 * A file started download.
		 */
		private function urlLoaderStartedHandler(event : Event) : void 
		{
			_isLoading = true;
		}

		/**
		 * The URLLoader dispatched an event while loading an audio file.
		 */
		private function urlLoaderEventHandler(event : Event) : void 
		{
			/** Remove listeners. */
			_urlLoader.removeEventListener(Event.COMPLETE, urlLoaderEventHandler);
			_urlLoader.removeEventListener(Event.OPEN, urlLoaderStartedHandler);
			_urlLoader.removeEventListener(ProgressEvent.PROGRESS, urlLoaderProgressEventHandler);
			_urlLoader.removeEventListener(SecurityErrorEvent.SECURITY_ERROR, urlLoaderEventHandler);
			_urlLoader.removeEventListener(IOErrorEvent.IO_ERROR, urlLoaderEventHandler);
			
			switch(event.type)
			{
				case Event.COMPLETE:
					_responder.result(URLLoader(event.target).data);
					break;
					
				case SecurityErrorEvent.SECURITY_ERROR:
					_responder.fault(new AlertVO("Security Error", "Error text: " + SecurityErrorEvent(event).text));
					break;
					
				case IOErrorEvent.IO_ERROR:
					_responder.fault(new AlertVO("IO Error", "Error text: " + IOErrorEvent(event).text));
					break;
			}
			// facade.sendNotification(AppFacade.ALERT, new AlertVO("Error", "Data for the sound loader not found. An audio file will not be loaded."));
		}
		
		/**
		 * Handle file load progress.
		 * @param event: ProgressEvent
		 */
		private function urlLoaderProgressEventHandler(event : ProgressEvent) : void 
		{
			/** Load progress code to be inserted here. */
		}
	}
}
